<script setup lang="ts">
  import { CmsPage, CmsSection, Product } from '@shopware-pwa/types';
  import { pascalCase } from 'scule';
  import { getCmsLayoutConfiguration } from '@shopware-pwa/helpers-next';
  import { useNavigationContext } from '@shopware-pwa/composables-next';
  import { CmsPageKey, CmsPageProductDetailKey } from '~/helpers/injection';
  import { SlideItem } from '~/logic/interfaces';

  const props = withDefaults(
    defineProps<{
      content: CmsPage;
      // define some new props
      type?: 'presentation' | 'page';
      options?: SlideItem;
    }>(),
    {
      type: 'page',
      options: undefined,
    },
  );

  // inject some new dependencies for generic usage
  provide(CmsPageKey, {
    type: props.type,
    options: props.options,
  });

  const { routeName } = useNavigationContext();
  if (routeName.value === 'frontend.navigation.page') {
    useListing();
  }

  const product = ref<Product>();

  if (['product_detail', 'presentation_product_detail'].includes(props.content.type)) {
    provide(CmsPageProductDetailKey, product);
  }

  const cmsSections = computed<CmsSection[]>(() => {
    return props.content?.sections || [];
  });

  const DynamicRender = () => {
    const componentsMap = cmsSections.value.map((section) => {
      return {
        component: resolveComponent(`CmsSection${pascalCase(section.type)}`),
        section,
      };
    });
    return componentsMap.map((componentObject) => {
      const { cssClasses, layoutStyles } = getCmsLayoutConfiguration(componentObject.section);
      if (typeof componentObject.component === 'string')
        return h('div', {}, 'There is no ' + componentObject.component);
      return h(componentObject.component, {
        content: componentObject.section,
        class: {
          [cssClasses ?? '']: true,
          'px-4': true,
          'max-w-screen-xl 3xl:max-w-screen-2xl mx-auto': layoutStyles?.sizingMode === 'boxed',
        },
        style: {
          backgroundColor: layoutStyles?.backgroundColor,
          backgroundImage: layoutStyles?.backgroundImage,
          backgroundSize: layoutStyles?.backgroundSize,
        },
      });
    });
  };
</script>

<template>
  <DynamicRender />
</template>
